## cgreen 1.5.1

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 2.8.12)

project(cgreen)

if (NOT(CMAKE_MAJOR_VERSION LESS 3) AND APPLE)
  if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # CMake 3.0 to use @rpath on MacOSX libraries
  endif()
endif()

find_package (Threads)

enable_testing()

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})
set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "5")
set(APPLICATION_VERSION_PATCH "1")
# If you change here, also change in include/cgreen/cgreen.h
# unless you write some code that automatically updates that...

set(APPLICATION_VERSION ${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}${APPLICATION_VERSION_STATUS})
add_definitions(-DVERSION="${APPLICATION_VERSION}")

set(LIBRARY_VERSION ${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH})
set(LIBRARY_SOVERSION ${APPLICATION_VERSION_MAJOR})

include(GNUInstallDirs)

if(MSVC)
  # these have sensible defaults on other platforms
  set(CMAKE_INSTALL_BINDIR ".")
  set(CMAKE_INSTALL_LIBDIR ".")
endif(MSVC)

set(BASHCOMPLETION_STATUS "Unavailable")
find_package(bash-completion QUIET)
if(BASH_COMPLETION_FOUND OR UNIX)
  set(BASHCOMPLETION_STATUS "Available")
  install(FILES tools/cgreen_completion.bash DESTINATION "${CMAKE_INSTALL_DATADIR}/bash-completion/completions" RENAME "cgreen-runner")
  install(FILES tools/cgreen_completion.bash DESTINATION "${CMAKE_INSTALL_DATADIR}/bash-completion/completions" RENAME  "cgreen-debug")
endif()

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefineCompilerFlags)
include(DefineOptions.cmake)
include(DefineCPackConfig)

# add macros
include(MacroAddPlugin)
include(MacroCopyFile)

# Generate gitrevision.h if Git is available and the .git directory is found.
find_program(GIT_EXECUTABLE git DOC "Git version control")
mark_as_advanced(GIT_EXECUTABLE)

# Find path to .git/logs/HEAD so that the gitrevision.h generation will only
# happen on new commits. This is done from $PROJECT_SOURCE_DIR because git rev-parse
# doesn't always return an absolute path so need to use get_filename_component()
# to get a cross-platform `readlink -f $(git rev-parse --git-path logs/HEAD)`
execute_process(
  COMMAND ${GIT_EXECUTABLE} rev-parse --git-path logs/HEAD
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  OUTPUT_VARIABLE GITDIR
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
if (GITDIR)
  get_filename_component(GITDIR "${GITDIR}" ABSOLUTE)
endif()

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)
# Dependency on our own library so we can use CGREEN_LIBRARY in all subdirectories
if (CGREEN_WITH_STATIC_LIBRARY)
  set(CGREEN_LIBRARY ${CGREEN_STATIC_LIBRARY})
else ()
  set(CGREEN_LIBRARY ${CGREEN_SHARED_LIBRARY})
endif()

add_subdirectory(doc)
add_subdirectory(include)
if (UNIX OR MSYS)
  # reflective runner only supported on UNIX/binutils platforms
  add_subdirectory(tools)
endif(UNIX OR MSYS)
# add_subdirectory(samples)

if (CGREEN_WITH_UNIT_TESTS)
  include(MacroAddUnitTest)
  include(MacroAddTest)
  include(MacroAddValgrindTest)
  add_subdirectory(tests)
  if (UNIX OR MSYS)
    # reflective runner only supported on UNIX/binutils platforms
    add_subdirectory(tools/tests)
  endif(UNIX OR MSYS)
endif (CGREEN_WITH_UNIT_TESTS)

# add custom 'check' target to run tests with output-on-failure
if (CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
        --force-new-ctest-process --output-on-failure
        --build-config "$<CONFIGURATION>")
else()
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
        --force-new-ctest-process --output-on-failure)
endif()

IF(CGREEN_INTERNAL_WITH_GCOV)
  IF(CMAKE_C_COMPILER_ID STREQUAL GNU)
    include(CodeCoverage)
    add_custom_target(coverage
        COMMAND ${LCOV_PATH} --directory . --capture --output-file coverage.info
        COMMAND ${LCOV_PATH} --remove coverage.info '/usr/*' -o coverage.info
        COMMAND ${GENHTML_PATH} -o coverage coverage.info
    )
  ENDIF()
ELSE()
  add_custom_target(coverage
      COMMAND echo "WARNING: Configure CGREEN_INTERNAL_WITH_GCOV to get coverage")
ENDIF()


#### Begin cgreen package configuration steps. ####

# After install other CMake projects can
# use find_package( cgreen )

set( CONFIG_INSTALL_DIR
        "${CMAKE_INSTALL_LIBDIR}/cmake/${APPLICATION_NAME}" )

set( PROJECT_CONFIG_IN
        "${CMAKE_CURRENT_SOURCE_DIR}/cgreen-config.cmake.in" )

set( VERSION_CONFIG_IN
        "${CMAKE_CURRENT_SOURCE_DIR}/cgreen-config-version.cmake.in" )

set( PROJECT_CONFIG
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cgreen-config.cmake" )

set( VERSION_CONFIG
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cgreen-config-version.cmake" )

configure_file( ${PROJECT_CONFIG_IN}
        "${PROJECT_CONFIG}" @ONLY )

configure_file( ${VERSION_CONFIG_IN}
        "${VERSION_CONFIG}" @ONLY )

install(FILES
        "${PROJECT_CONFIG}" "${VERSION_CONFIG}"
        DESTINATION
        "${CONFIG_INSTALL_DIR}" )

#### End cgreen package configuration steps. ####

=== Makefile ===
# This Makefile ensures that the build is made out of source in a
# subdirectory called 'build' If it doesn't exist, it is created.
#
# This Makefile also contains delegation of the most common make commands
#
# If you have cmake installed you should be able to do:
#
#	make
#	make test
#	make install
#	make package
#
# That should build Cgreen in the build directory, run some tests,
# install it locally and generate a distributable package.

ifndef VERBOSE
MAKEFLAGS += --no-print-directory
endif

.PHONY:all
all: build-it

.PHONY:debug
debug: build
	cmake -DCMAKE_BUILD_TYPE:string=Debug -S . -B build
	cmake --build build

32bit: build
	-rm -rf build; mkdir build; cd build; cmake -DCMAKE_C_FLAGS="-m32" -DCMAKE_CXX_FLAGS="-m32" $(GENERATOR) ..; $(MAKE)

.PHONY:test
test: build-it
	ctest --test-dir build

.PHONY:clean
clean: build/Makefile
	cd build; $(MAKE) clean

.PHONY:package
package: build/Makefile
	cd build; $(MAKE) package

.PHONY:install
install: build
ifeq ($(OS),Msys)
  # Thanks to https://stackoverflow.com/a/46027426/204658
  cd build; $(MAKE) install DESTDIR=/
else
	cd build; $(MAKE) install
endif

# This is kind of a hack to get a quicker and clearer feedback when
# developing Cgreen by allowing 'make unit'. Must be updated when new
# test libraries or output comparisons are added.

# Find out if 'uname -o' works, if it does - use it, otherwise use 'uname -s'
UNAMEOEXISTS=$(shell uname -o &>/dev/null; echo $$?)
ifeq ($(UNAMEOEXISTS),0)
  OS=$(shell uname -o)
else
  OS=$(shell uname -s)
endif

# Set prefix and suffix for shared libraries depending on platform
ifeq ($(OS),Darwin)
	LDPATH=DYLD_LIBRARY_PATH=$(PWD)/build/src
	PREFIX=lib
	SUFFIX=.dylib
else ifeq ($(OS),Cygwin)
	LDPATH=PATH=$(PWD)/build/src:"$$PATH"
	PREFIX=cyg
	SUFFIX=.dll
else ifeq ($(OS),Msys)
# This is for Msys "proper"
# TODO: handle Msys/Mingw32/64
	LDPATH=PATH=$(PWD)/build/src:"$$PATH"
	PREFIX=msys-
	SUFFIX=.dll
else
	LDPATH=LD_LIBRARY_PATH=$(PWD)/build/src
	PREFIX=lib
	SUFFIX=.so
endif

# TODO: the diff_tools scripts determine prefix and extension by themselves
# Would be better if those were arguments, since we do it here anyway

DIFF_TOOL=../../tools/cgreen_runner_output_diff
XML_DIFF_TOOL=../../tools/cgreen_xml_output_diff
DIFF_TOOL_ARGUMENTS = $(1)_tests \
	../../tests \
	$(1)_tests.expected

.PHONY: unit
unit: build-it
	if [ -f build/tools/cgreen-runner ]; then \
		cd build ; \
		$(LDPATH) tools/cgreen-runner -c `find tests -name $(PREFIX)cgreen_c_tests$(SUFFIX)` ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) tools/cgreen-runner -c `find tests -name $(PREFIX)cgreen_cpp_tests$(SUFFIX)` ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) tools/cgreen-runner -c `find tools/tests -name $(PREFIX)cgreen_runner_tests$(SUFFIX)` ; \
		r=$$((r + $$?)) ; \
		cd tests ; \
		$(LDPATH) $(XML_DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,xml_output) ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,assertion_messages) ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,mock_messages) ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,constraint_messages) ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,custom_constraint_messages) ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,ignore_messages) ; \
		r=$$((r + $$?)) ; \
		$(LDPATH) CGREEN_PER_TEST_TIMEOUT=1 $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,failure_messages) ; \
		r=$$((r + $$?)) ; \
		exit $$r; \
	fi

.PHONY: doc
doc: build
	cmake -DCGREEN_WITH_HTML_DOCS:bool=TRUE -S . -B build
	cmake --build build
	cmake -DCGREEN_WITH_HTML_DOCS:bool=False
	echo open $(PWD)/build/doc/cgreen-guide-en.html

pdf: build
	cmake -DCGREEN_WITH_PDF_DOCS:bool=TRUE -S . -B build
	cmake --build build
	cmake -DCGREEN_WITH_PDF_DOCS:bool=FALSE -S . -B build
	echo open $(PWD)/build/doc/cgreen-guide-en.pdf

chunked: doc
	asciidoctor-chunker build/doc/cgreen-guide-en.html -o docs
	echo open $(PWD)/docs/index.html

############# Internal
.PHONY:build-it
build-it: build/Makefile
	cmake --build build

build:
	mkdir -p build

build/Makefile: | build
ifeq ($(OS),Darwin)
	#cmake -DCMAKE_OSX_ARCHITECTURES="arm64e;x86_64" -S . -B build
	cmake -S . -B build
else
	cmake -S . -B build
endif

.SILENT:

=== src/CMakeLists.txt ===
# Generate gitrevision.h
if (GITREVISION)
  # Allow GITREVISION to be overridden manually / externally. This useful for vendoring.
  message(INFO, "GITREVISION manually overridden: ${GITREVISION}")
else()
  if (GITDIR AND GIT_EXECUTABLE)
    # Use the git version if Git is available and the .git directory is found.
    # NOTE: $GITDIR is determined in top-level CMakeLists.txt
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --always --abbrev=7 --dirty=-modified
                    OUTPUT_VARIABLE GITREVISION
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    # No version control
    # e.g. when the software is built from a source tarball
    message(WARNING "-- Unable to find git, or not a repo. Setting git revision to 'unknown'.")
    set(GITREVISION "unknown")
  endif()
endif()

configure_file(${PROJECT_SOURCE_DIR}/gitrevision.h.in ${PROJECT_SOURCE_DIR}/gitrevision.h @ONLY)

set(CGREEN_PUBLIC_INCLUDE_DIRS
  ${PROJECT_SOURCE_DIR}/
  ${PROJECT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}
  CACHE INTERNAL "cgreen public include directories"
)

set(CGREEN_PRIVATE_INCLUDE_DIRS
  ${PROJECT_BINARY_DIR}
)

if (MSVC)
  LIST(APPEND CGREEN_PRIVATE_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}/../include/cgreen/internal/windows_headers
  )
endif(MSVC)

set(CGREEN_SHARED_LIBRARY
  cgreen_shared
  CACHE INTERNAL "cgreen shared library"
)

if (WIN32 AND NOT CYGWIN)
  set(CGREEN_LINK_LIBRARIES
    winmm.lib
  )
endif(WIN32 AND NOT CYGWIN)

set(cgreen_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/assertions.c
  ${CMAKE_CURRENT_SOURCE_DIR}/boxed_double.c
  ${CMAKE_CURRENT_SOURCE_DIR}/breadcrumb.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cgreen_time.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cgreen_value.c
  ${CMAKE_CURRENT_SOURCE_DIR}/constraint.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cute_reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cdash_reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/messaging.c
  ${CMAKE_CURRENT_SOURCE_DIR}/message_formatting.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mocks.c
  ${CMAKE_CURRENT_SOURCE_DIR}/parameters.c
  ${CMAKE_CURRENT_SOURCE_DIR}/reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/runner.c
  ${CMAKE_CURRENT_SOURCE_DIR}/string_comparison.c
  ${CMAKE_CURRENT_SOURCE_DIR}/suite.c
  ${CMAKE_CURRENT_SOURCE_DIR}/text_reporter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.c
  ${CMAKE_CURRENT_SOURCE_DIR}/vector.c
  ${CMAKE_CURRENT_SOURCE_DIR}/xml_reporter.c
)

if (MSYS)
  # Msys2 is difficult since it really is three different "OS":es, Msys native, W32 and W64
  # To get somewhere, let's use the native Msys2, which actually is Cygwin/UNIX.
  LIST(APPEND cgreen_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_pipe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_time.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_runner_platform.c
  )
elseif (UNIX OR CYGWIN)
  LIST(APPEND cgreen_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_pipe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_cgreen_time.c
    ${CMAKE_CURRENT_SOURCE_DIR}/posix_runner_platform.c
  )
elseif(WIN32)
 LIST(APPEND cgreen_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/win32_cgreen_pipe.c
    ${CMAKE_CURRENT_SOURCE_DIR}/win32_cgreen_time.c
    ${CMAKE_CURRENT_SOURCE_DIR}/win32_runner_platform.c
  )
else()
  message(FATAL_ERROR "Cgreen can currently only be compiled for Linux, Cygwin, MacOSX and Msys2 (native, not MingW versions). Patches are welcome!")
endif()
SET_SOURCE_FILES_PROPERTIES(${cgreen_SRCS} PROPERTIES LANGUAGE C)

set(cgreen_SRCS ${cgreen_SRCS}
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp_assertions.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cpp_constraint.cpp
)
SET_SOURCE_FILES_PROPERTIES(cpp_assertions.cpp cpp_constraint.cpp PROPERTIES LANGUAGE CXX )


include(DefineRelativeFilePaths)
cmake_define_relative_file_paths ("${cgreen_SRCS}")

include_directories(
  ${CGREEN_PUBLIC_INCLUDE_DIRS}
  ${CGREEN_PRIVATE_INCLUDE_DIRS}
)

### cgreen
set(CGREEN_LIBRARY_NAME cgreen)
add_library(${CGREEN_SHARED_LIBRARY} SHARED ${cgreen_SRCS} ${PROJECT_SOURCE_DIR}/gitrevision.h)

target_link_libraries(
  ${CGREEN_SHARED_LIBRARY}
  ${CGREEN_LINK_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${MATH_LIB}
  ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}
)

set_target_properties(
  ${CGREEN_SHARED_LIBRARY}
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
      OUTPUT_NAME
        ${CGREEN_LIBRARY_NAME}
)

install(
  TARGETS ${CGREEN_SHARED_LIBRARY}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT libraries
)

if (CGREEN_WITH_STATIC_LIBRARY)

  set(CGREEN_STATIC_LIBRARY
    cgreen_static
    CACHE INTERNAL "cgreen static library"
  )

  add_library(${CGREEN_STATIC_LIBRARY} STATIC ${cgreen_SRCS})

  target_link_libraries(${CGREEN_STATIC_LIBRARY}
    ${CGREEN_LINK_LIBRARIES}
    ${MATH_LIB}
    ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}
  )

  set_target_properties(
    ${CGREEN_STATIC_LIBRARY}
      PROPERTIES
        VERSION
          ${LIBRARY_VERSION}
        SOVERSION
          ${LIBRARY_SOVERSION}
        OUTPUT_NAME
          ${CGREEN_LIBRARY_NAME}
  )

  install(
    TARGETS ${CGREEN_STATIC_LIBRARY}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT libraries
  )
endif(CGREEN_WITH_STATIC_LIBRARY)

=== tests/CMakeLists.txt ===
set(CGREEN_TEST_INCLUDE_DIRS
  ${CGREEN_PUBLIC_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
)

check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
if (HAVE_SYS_RESOURCE_H)
  add_definitions(-DHAVE_SYS_RESOURCE_H)
endif(HAVE_SYS_RESOURCE_H)

if (MSVC)
  LIST(APPEND CGREEN_TEST_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}/include/cgreen/internal/windows_headers
  )
endif(MSVC)


include_directories(${CGREEN_TEST_INCLUDE_DIRS})

# C tests, library to use with runner, and a main program
# NOTE that some of these are "pure" unit tests which only
# need to work in C, since Cgreen's internal is C.
# Some others are actually testing user level functionality
# which must work both for C and C++ compiles.
# TODO: separate out those into separate dirs? Or just
# two lists of files, one which should go into C++ compilation
# too.
set(c_tests_library_SRCS
  assertion_tests.c
  breadcrumb_tests.c
  cdash_reporter_tests.c
  cgreen_value_tests.c
  constraint_tests.c
  cute_reporter_tests.c
  double_tests.c
  environment_variables_tests.c
  message_formatting_tests.c
  messaging_tests.c
  mocks_tests.c
  parameters_tests.c
  reflective_runner_no_teardown_tests.c
  reflective_tests.c
  text_reporter_tests.c
  unit_tests.c
  vector_tests.c
  xml_reporter_tests.c
)
SET_SOURCE_FILES_PROPERTIES(${c_tests_library_SRCS} PROPERTIES LANGUAGE C)

set(CGREEN_C_TESTS_LIBRARY
  cgreen_c_tests
  CACHE INTERNAL "cgreen shared library with tests for C"
)

add_library(${CGREEN_C_TESTS_LIBRARY} SHARED ${c_tests_library_SRCS})
target_link_libraries(${CGREEN_C_TESTS_LIBRARY} ${CGREEN_LIBRARY})
macro_add_valgrind_test(${CGREEN_C_TESTS_LIBRARY})


set(c_tests_SRCS
  all_c_tests.c
  ${c_tests_library_SRCS}
)
SET_SOURCE_FILES_PROPERTIES(${c_tests_SRCS} PROPERTIES LANGUAGE C)

set(TEST_TARGET_LIBRARIES ${CGREEN_LIBRARY})

# unit test with main program runner
macro_add_unit_test(test_cgreen_c "${c_tests_SRCS}" "${TEST_TARGET_LIBRARIES}")
macro_add_test(NAME test_cgreen_c_run_named_test COMMAND test_cgreen_c integer_one_should_assert_true)

find_package(LibBfd)
if(LibBfd_FOUND)
  # run them with cgreen-runner also
  macro_add_test(NAME runner_test_cgreen_c COMMAND cgreen-runner -x TEST ./${CMAKE_SHARED_LIBRARY_PREFIX}${CGREEN_C_TESTS_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

# C++ tests, library to use with runner, and a main program
# NOTE that .cpp-versions should be links to .c-versions so we avoid duplication
# so we just use the same list and add the CPP-specific tests here
foreach(c_test_file ${c_tests_library_SRCS})
  string(REGEX REPLACE "\\.c" ".cpp" cpp_test_file ${c_test_file})
  list(APPEND cpp_tests_library_SRCS ${cpp_test_file})
endforeach()

set(cpp_tests_library_SRCS
  ${cpp_tests_library_SRCS}
  cpp_assertion_tests.cpp
  )

SET_SOURCE_FILES_PROPERTIES(${cpp_tests_library_SRCS} PROPERTIES LANGUAGE CXX)

set(CGREEN_CPP_TESTS_LIBRARY
  cgreen_cpp_tests
  CACHE INTERNAL "cgreen shared library with tests for C++"
)
add_library(${CGREEN_CPP_TESTS_LIBRARY} SHARED ${cpp_tests_library_SRCS})
target_link_libraries(${CGREEN_CPP_TESTS_LIBRARY} ${CGREEN_LIBRARY} ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
macro_add_valgrind_test(${CGREEN_CPP_TESTS_LIBRARY})


set(cpp_tests_SRCS
  all_cpp_tests.cpp
  ${cpp_tests_library_SRCS}
)
SET_SOURCE_FILES_PROPERTIES(${cpp_tests_SRCS} PROPERTIES LANGUAGE CXX)

macro_add_unit_test(test_cgreen_cpp "${cpp_tests_SRCS}" "${TEST_TARGET_LIBRARIES}" ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
macro_add_test(NAME test_cgreen_cpp_run_named_test COMMAND test_cgreen_cpp different_pointers_with_same_contents_should_assert_equal)

find_package(LibBfd)
if(LibBfd_FOUND)
  macro_add_test(NAME runner_test_cgreen_cpp COMMAND cgreen-runner -x TEST ./${CMAKE_SHARED_LIBRARY_PREFIX}${CGREEN_CPP_TESTS_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX})

  # Temporary single CUT test library
  # Maybe we should do this for all tests instead
  # and then aggregate the DLL/so/dylibs instead...
  # Then this might be possible to turn into a macro
  # which could allow "add_runner_lib(text_reporter)"
  foreach(case
      assertion
      breadcrumb
      cdash_reporter
      cgreen_value
      constraint
      cute_reporter
      double
      message_formatting
      messaging
      mocks
      parameters
      reflective
      reflective_runner_no_teardown
      text_reporter
      unit
      vector
      xml_reporter
    )
    set(${case}_tests_SRCS
        ${case}_tests.c
    )
    set(${case}_tests_library
        ${case}_tests
    )
    add_library(${${case}_tests_library} SHARED ${${case}_tests_SRCS})
    target_link_libraries(${${case}_tests_library} ${CGREEN_LIBRARY})
    macro_add_valgrind_test(${${case}_tests_library})
  endforeach(case)


  # Libraries for a set of output comparing tests to run with runner

  set(constraint_messages_library constraint_messages_tests)
  set(constraint_messages_library_SRCS constraint_messages_tests.c)
  add_library(${constraint_messages_library} SHARED ${constraint_messages_library_SRCS})
  target_link_libraries(${constraint_messages_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${constraint_messages_library})

  set(custom_constraint_messages_library custom_constraint_messages_tests)
  set(custom_constraint_messages_library_SRCS custom_constraint_messages_tests.c)
  add_library(${custom_constraint_messages_library} SHARED ${custom_constraint_messages_library_SRCS})
  target_link_libraries(${custom_constraint_messages_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${custom_constraint_messages_library})

  set(mock_messages_library mock_messages_tests)
  set(mock_messages_library_SRCS mock_messages_tests.c)
  add_library(${mock_messages_library} SHARED ${mock_messages_library_SRCS})
  target_link_libraries(${mock_messages_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${mock_messages_library})

  set(failure_messages_library failure_messages_tests)
  set(failure_messages_library_SRCS failure_messages_tests.c)
  add_library(${failure_messages_library} SHARED ${failure_messages_library_SRCS})
  target_link_libraries(${failure_messages_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${failure_messages_library})

  set(assertion_messages_library assertion_messages_tests)
  set(assertion_messages_library_SRCS assertion_messages_tests.c)
  add_library(${assertion_messages_library} SHARED ${assertion_messages_library_SRCS})
  target_link_libraries(${assertion_messages_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${assertion_messages_library})

  set(ignore_messages_library ignore_messages_tests)
  set(ignore_messages_library_SRCS ignore_messages_tests.c)
  add_library(${ignore_messages_library} SHARED ${ignore_messages_library_SRCS})
  target_link_libraries(${ignore_messages_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${ignore_messages_library})

  set(xml_output_library xml_output_tests)
  set(xml_output_library_SRCS xml_output_tests.c)
  add_library(${xml_output_library} SHARED ${xml_output_library_SRCS})
  target_link_libraries(${xml_output_library} ${CGREEN_LIBRARY})
  macro_add_valgrind_test(${xml_output_library})

  set(TEST_TARGET_LIBRARIES ${CGREEN_LIBRARY})

  macro_add_test(
      NAME constraint_messsages
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
              constraint_messages_tests       # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${constraint_messages_library}.expected
  )

  macro_add_test(
      NAME custom_constraint_messsages
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
              custom_constraint_messages_tests       # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${custom_constraint_messages_library}.expected
  )

  macro_add_test(
      NAME mock_messsages
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
              mock_messages_tests             # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${mock_messages_library}.expected
  )

  macro_add_test(NAME failure_messages
      COMMAND env "CGREEN_PER_TEST_TIMEOUT=2" ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
              failure_messages_tests          # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${failure_messages_library}.expected
  )

  macro_add_test(NAME assertion_messages
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
              assertion_messages_tests        # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${assertion_messages_library}.expected
  )

  macro_add_test(NAME ignore_messages
      COMMAND env "CGREEN_PER_TEST_TIMEOUT=2" ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
              ignore_messages_tests           # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${ignore_messages_library}.expected
  )

  macro_add_test(NAME xml_output
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_xml_output_diff
              xml_output_tests                # Name
              ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
              ${xml_output_library}.expected
  )

endif()
# add verification that all public api is available as it should
add_subdirectory(api)

=== tests/Makefile ===
# This make file may serve as an example of how to easily build a lot
# of Cgreen test libraries and run them through the runner. By
# structuring it this way only affected libraries need to be rebuilt.
#
# Note that this is not official builds or tests for Cgreen. To do
# that you should go to root directory and do "make unit" or "make
# test"

CFLAGS = -Wall -fPIC -std=c99 -I../include -I.. -I../src

LIBRARY_PATH = ../build/src
ifneq ($(shell uname), Darwin)
LOAD_PATH = LD_LIBRARY_PATH=$(LIBRARY_PATH)
else
LOAD_PATH = DYLD_LIBRARY_PATH=$(LIBRARY_PATH)
endif

TEST_SOURCES = \
	assertion_tests.c \
	breadcrumb_tests.c \
	cdash_reporter_tests.c \
	cgreen_value_tests.c \
	constraint_tests.c \
	cute_reporter_tests.c \
	double_tests.c \
	environment_variables_tests.c \
	message_formatting_tests.c \
	messaging_tests.c \
	mocks_tests.c \
	parameters_tests.c \
	reflective_runner_no_teardown_tests.c \
	reflective_tests.c \
	text_reporter_tests.c \
	unit_tests.c \
	utils_tests.c \
	vector_tests.c \
	xml_reporter_tests.c \

TEST_LIBRARIES = $(patsubst %.c,lib%.so, $(TEST_SOURCES))

all: $(TEST_LIBRARIES)
	cd ..; make --no-print-directory
	if [ -f ../build/tools/cgreen-runner ]; then \
		$(LOAD_PATH) ../build/tools/cgreen-runner -s unittests $?; \
	fi

lib%_tests.so : %_tests.o ; $(CC) -shared -o $@ $^ -L$(LIBRARY_PATH) -lcgreen

=== tools/CMakeLists.txt ===
find_package(LibBfd)

if(LibBfd_FOUND)
  include_directories(${CGREEN_PUBLIC_INCLUDE_DIRS} ${PROJECT_BINARY_DIR} ${LIBBFD_INCLUDE_DIRS})

  # Need to explicitly add libintl - Cygwin issue with binutils-2.37-2
  if (CYGWIN)
    find_library(EXPLICIT_INTLIB_ONLY_REQUIRED_FOR_CYGWIN NAMES intl libintl)
  else ()
    set(EXPLICIT_INTLIB_ONLY_REQUIRED_FOR_CYGWIN "")
  endif()

  set(RUNNER_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/cgreen-runner.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gopt.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gopt-errors.c
    ${CMAKE_CURRENT_SOURCE_DIR}/runner.c
    ${CMAKE_CURRENT_SOURCE_DIR}/discoverer.c
    ${CMAKE_CURRENT_SOURCE_DIR}/test_item.c
    ${CMAKE_CURRENT_SOURCE_DIR}/bfd_adapter.c
  )
  set_source_files_properties(${RUNNER_SRCS} PROPERTIES LANGUAGE C)

  include(DefineRelativeFilePaths)
  cmake_define_relative_file_paths ("${RUNNER_SRCS}")

  add_executable(cgreen-runner ${RUNNER_SRCS})
  target_link_libraries(cgreen-runner PRIVATE
    ${CGREEN_LIBRARY}
    ${CMAKE_DL_LIBS}
    ${LIBBFD_LIBRARIES}
    ${EXPLICIT_INTLIB_ONLY_REQUIRED_FOR_CYGWIN}
  )

  install(TARGETS cgreen-runner
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    DESTINATION ${CMAKE_INSTALL_BINDIR}
  )

  install(PROGRAMS cgreen-debug
    DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
  message(WARNING "libbfd not found, cgreen-runner will not be built")
endif()

=== tools/Makefile ===
# Makefile to run unit tests for cgreen-runner units
#
# We are using cgreen itself to test this but since the modules here
# might at some point get into the actual cgreen-runner there will be
# a clash when it loads the test library. So we will have to make the
# external symbols in the modules have other names when unittesting
# them using macro magic. The UNITTESTING preprocessor symbol will
# add the suffix '_unittesting' to externally, clashing symbols so
# that we can separate the once in the cgreen-runner that is running
# the tests, and the ones in the units being tested.

UNAMEOEXISTS=$(shell uname -o 1>&2 2>/dev/null; echo $$?)
ifeq ($(UNAMEOEXISTS),0)
  OS=$(shell uname -o)
else
  OS=$(shell uname -s)
endif

CFLAGS = -Wall -g -I../include -MMD -DUNITTESTING -I.
ifneq ($(OS),Cygwin)
  CFLAGS+=-fPIC
endif

LDFLAGS = $(COMMONFLAGS)

LIBRARIES = -L../build/src -lcgreen

VPATH = ../src

ifeq ($(OS),Darwin)
	LD_PATH_NAME=DYLD_LIBRARY_PATH
else
	LD_PATH_NAME=LD_LIBRARY_PATH
endif

CGREEN_RUNNER = $(LD_PATH_NAME)=../build/src cgreen-runner


# Redirect to CMake build from top level
all:
	make --no-print-directory -C ..

# Use this if you want quick feed back in this directory
tests: unit_tests acceptance_tests

#----------------------------------------------------------------------
unit unit_tests: discoverer_unit_tests
	./discoverer_unit_tests

discoverer_unit_tests: discoverer_unit_test_runner.o discoverer.o test_item.o
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBRARIES)

discoverer_unit_test_runner.c : tests/discoverer_unit_tests.c
	echo "#include \"tests/discoverer_unit_tests.c\"" > discoverer_unit_test_runner.c
	echo "TestSuite *discoverer_unit_tests() {" >> discoverer_unit_test_runner.c
	echo "    TestSuite *suite = create_test_suite();" >> discoverer_unit_test_runner.c
	grep Ensure tests/discoverer_unit_tests.c | sed -e 's/Ensure(/    add_test_with_context(suite, /g' -e 's/) {/);/g' >> discoverer_unit_test_runner.c
	echo "    return suite;" >> discoverer_unit_test_runner.c
	echo "}" >> discoverer_unit_test_runner.c
	echo "int main(int argc, char **argv) {" >> discoverer_unit_test_runner.c
	echo "    return run_test_suite(discoverer_unit_tests(), create_text_reporter());" >> discoverer_unit_test_runner.c
	echo "}" >> discoverer_unit_test_runner.c

#----------------------------------------------------------------------
acceptance_tests: libdiscoverer_acceptance_tests.so
	$(CGREEN_RUNNER) $^

libdiscoverer_acceptance_tests.so: tests/discoverer_acceptance_tests.o discoverer.o test_item.o io.o
	$(CC) -shared -o $@ $^ $(LIBRARIES)

#----------------------------------------------------------------------
clean:
	-rm *.o *.so *.dll

-include *.d

=== doc/tutorial_src/Makefile ===
# This Makefile generates source and output that is part of Cgreen
# documentation. Files here are included in the asciidoc source so be
# careful with what you commit, it might thrash the documentation. In
# particular, be aware that non-UTF-8 characters in them (usually)
# makes generation of PDF impossible.  'stream2' and 'stream5' might
# generate random data as 'actual' values in the output file. That is
# the way it is supposed to be to work as documentation examples.
# Take care that data is printable but looks random.

CFLAGS = -Wall -g

.IGNORE :
.SILENT :

CGREEN_ROOT=../..

# Point to MySQL includes and linking for the MySQL examples
ifeq ($(shell uname),Darwin)
MYSQL_INCLUDE = /opt/local/include/mysql56/mysql
MYSQL_LIB = /opt/local/lib/mysql56/mysql
else
ifeq ($(shell uname -o),Cygwin)
MYSQL_INCLUDE = /usr/include/mysql
MYSQL_LIB = /usr/lib
else
MYSQLROOT = /usr
MYSQL_INCLUDE = $(MYSQLROOT)/include/mysql
MYSQL_LIB = $(MYSQLROOT)/lib
endif
endif

CGREEN_BIN=$(CGREEN_ROOT)/build
CC = gcc -c -g -Wall -I$(CGREEN_ROOT)/include -I$(CGREEN_ROOT)/src -I$(MYSQL_INCLUDE) $(FPIC)
LINK = gcc -g
LIBDIRS = -L$(CGREEN_BIN)/src -L$(MYSQL_LIB)

# Enviroment dependent fixup of the various paths to use bins & libs in this development tree
FPIC = -fPIC	# required on Linux, Darwin, ...
ifeq ($(shell uname),Darwin)
LDPATH = DYLD_LIBRARY_PATH="$(CGREEN_BIN)/src:$(MYSQL_LIB)"
else
ifeq ($(shell uname -o),Cygwin)
FPIC=
LDPATH = PATH="$(CGREEN_BIN)/src:$(MYSQL_LIB)"
else
LDPATH = LD_LIBRARY_PATH="$(CGREEN_BIN)/src:$(MYSQL_LIB)"
endif
endif

RUNNER = $(LDPATH) $(CGREEN_BIN)/tools/cgreen-runner


all: with_main with_runner special
	echo
	echo "NOTE: 'stream2.out' and 'stream5.out' should contain a simulation"
	echo "NOTE: of random memory as the actual value. Don't commit changes that do"
	echo "NOTE: not. But also note that PDF generation of the documentation"
	echo "NOTE: will fail if there are non-UTF-8 characters in them."

# Since we have multiple files for the same tutorial example, distinguished by a number,
# we need to remove that number from all output
REMOVE_NUMBERS=-e 's/\([a-z]\)[0-9]\+\"/\1\"/' -e 's/\([a-z]\)[0-9]\+\.c/\1\.c/'

# To minimize the diffs we also need to normalize execution times
NORMALIZE_DURATION=-e 's/\ in\ [0-9]\+ms/\ in\ 42ms/g'

# And batch that together in one symbol
SED=sed $(REMOVE_NUMBERS) $(NORMALIZE_DURATION)

with_main:  first0 first1 \
			words0 words1 words2 words3 words4 words5 words6 words7 words8 words9 \
			strlen1 strlen2 strlen3 strlen4 strlen5 strlen6 strlen7 \
			double1 \
			schema1 schema2 \
			crash1 crash2 crash3 \
			suite1 \
			test_as_xml0 \
			test_as_xml1 \
			test_as_xml2 \
			test_as_xml3 \
			test_as_xml4 \
			custom_constraint1 \
			custom_constraint2 \
			custom_constraint3
	for f in $^ ; do echo $$f; $(LDPATH) ./$$f | $(SED) > $$f.out; done

# Most tests built to run with the runner we can run here, but some need special care
# They have their output produced directly in their build rules below and are run using
# the 'special' rule
with_runner: set_content side_effect stream0 stream1 stream2 stream3 stream4 stream6 \
			 multiple_streams1 multiple_streams2 \
			 formatter0 formatter1 formatter2 formatter3 formatter4 formatter5 formatter6
	for f in $^ ; do echo $$f; $(RUNNER) $$f.so | $(SED) > $$f.out; done

special: runner1 runner2 runner3 stream5 learning_mocks

clean:
	rm -f *.exe *.o *.out *.so *.stackdump *~

first_tests0.o: first_tests0.c
	$(CC) -o $@ -c $^ $(CFLAGS) -Wno-unused-variable

first0: first_tests0.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

first1: first_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words_tests0.o: words_tests0.c
	$(CC) -o $@ -c $^ $(CFLAGS) -Wno-unused-variable

words0: all_tests.o words_tests0.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words1: all_tests.o words_tests1.o words1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words2: all_tests.o words_tests1.o words2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words3: all_tests.o words_tests2.o words2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words4: all_tests.o words_tests2.o words3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words5: all_tests.o words_tests2.o words4.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words6: all_tests.o words_tests3.o words5.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words7: all_tests.o words_tests3.o words6.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words8: all_tests.o words_tests4.o words6.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

words9: all_tests.o words_tests4.o words7.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen1: strlen_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen2: strlen_tests2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen3: strlen_tests3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen4: strlen_tests4.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen5: strlen_tests5.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen6: strlen_tests6.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

strlen7: strlen_tests7.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

double1: double_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

schema1: schema_tests1.o person.h
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen -lmysqlclient

schema2: schema_tests2.o person.h
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen -lmysqlclient

crash1: crash_tests1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

crash2: crash_tests2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

crash3: crash_tests3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

suite1: suite1.o suite_person_tests.o suite_strlen_tests.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen -lmysqlclient

test_as_xml0: test_as_xml0.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml1: test_as_xml1.o xml_reporter1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml2: test_as_xml1.o xml_reporter2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml3: test_as_xml1.o xml_reporter3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

test_as_xml4: test_as_xml1.o xml_reporter4.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

custom_constraint1: custom_constraint1.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

custom_constraint2: custom_constraint2.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen

custom_constraint3: custom_constraint3.o
	$(LINK) -o $@ $^ $(LIBDIRS) -lcgreen



###########################################################
# With runner
#
# All these examples run using the runner which automatically outputs the file name
# Since that includes the example #, which we don't want in the tutorial, we use
# sed to remove that number from the file name in the output
.PHONY: set_content
set_content: stream_tests0.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: side_effect
side_effect: stream_tests0.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream0
stream0: stream_tests0.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream1
stream1: stream_tests1.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream2
stream2: stream_tests2.o read_paragraph1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream3
stream3: stream_tests2.o read_paragraph2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream4
stream4: stream_tests3.o read_paragraph2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: stream5
# This test generates random characters read from memory so we need to tidy that up
stream5: stream_tests4.o read_paragraph2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) $@.so | $(SED) > $@.out
	echo "Trying to remove non-characters from stream5.out"
	echo "Check manually if the following sed fails:"
	cp $@.out $@.bak && LANG='' sed -e 's/^[^[[:space:]].*"]/"]/g' $@.bak > $@.bak2 && mv $@.bak2 $@.out
	rm $@.bak

.PHONY: stream6
stream6: stream_tests4.o read_paragraph3.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: multiple_streams1
multiple_streams1: multiple_streams1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: multiple_streams2
multiple_streams2: multiple_streams2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

.PHONY: runner1
runner1: first_tests2.o
	$(LINK) -shared -o first_tests.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) first_tests.so | $(SED) > $@.out

.PHONY: runner2
runner2: first_tests2.o
	$(LINK) -shared -o first_tests.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) first_tests.so Cgreen:fails_this_test | $(SED) > $@.out

.PHONY: runner3
runner3: first_tests2.o
	$(LINK) -shared -o first_tests.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) -v first_tests.so Cgreen:fails_this_test | $(SED) > $@.out

.PHONY: formatter0
formatter0: stream1.o formatter_tests0.o
	$(LINK) -shared -o formatter_tests.so $^ $(LIBDIRS) -lcgreen

.PHONY: formatter1
formatter1: stream1.o formatter_tests1.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter2: stream1.o formatter_tests2.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter3: stream1.o formatter_tests3.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter4: stream1.o formatter_tests4.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter5: stream1.o formatter_tests5.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

formatter6: stream2.o formatter_tests5.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen

learning_mocks: learning_mocks.o
	$(LINK) -shared -o $@.so $^ $(LIBDIRS) -lcgreen
	$(RUNNER) $@.so

=== tools/tests/CMakeLists.txt ===
find_package(LibBfd)

if(LibBfd_FOUND)

  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/..
    ${CGREEN_PUBLIC_INCLUDE_DIRS}
    ${CURRENT_BINARY_DIR}
    ${LIBBFD_INCLUDE_DIRS})

  set(CGREEN_RUNNER_TESTS_LIBRARY
    cgreen_runner_tests
    CACHE INTERNAL "cgreen-runner tests shared library"
  )
  set(RUNNER_TESTS_SRCS
    runner_unit_tests.c
    ../discoverer.c
    ../bfd_adapter.c
    ../test_item.c)
  add_library(${CGREEN_RUNNER_TESTS_LIBRARY} SHARED ${RUNNER_TESTS_SRCS})
  target_link_libraries(${CGREEN_RUNNER_TESTS_LIBRARY}
    ${CGREEN_LIBRARY}
    ${CMAKE_DL_LIBS}
    ${LIBBFD_LIBRARIES}
    ${EXPLICIT_INTLIB_ONLY_REQUIRED_FOR_CYGWIN}
  )

  set(DISCOVERER_ACCEPTANCE_TESTS_LIBRARY
    discoverer_acceptance_tests
    CACHE INTERNAL "discoverer acceptance tests"
  )
  set(DISCOVERER_ACCEPTANCE_TESTS_SRCS
    discoverer_acceptance_tests.c
    ../discoverer.c
    ../bfd_adapter.c
    ../test_item.c)
  add_library(${DISCOVERER_ACCEPTANCE_TESTS_LIBRARY} SHARED ${DISCOVERER_ACCEPTANCE_TESTS_SRCS})

  target_link_libraries(${DISCOVERER_ACCEPTANCE_TESTS_LIBRARY}
    ${CGREEN_LIBRARY}
    ${CMAKE_DL_LIBS}
    ${LIBBFD_LIBRARIES}
    ${EXPLICIT_INTLIB_ONLY_REQUIRED_FOR_CYGWIN}
  )

  set(DISCOVERER_UNIT_TESTS_LIBRARY
    discoverer_unit_tests
    CACHE INTERNAL "discoverer unit tests"
  )
  set(DISCOVERER_UNIT_TESTS_SRCS
    discoverer_unit_tests.c
    ../discoverer.c
    ../test_item.c)
  add_library(${DISCOVERER_UNIT_TESTS_LIBRARY} SHARED ${DISCOVERER_UNIT_TESTS_SRCS})

  target_compile_definitions(${DISCOVERER_UNIT_TESTS_LIBRARY} PUBLIC UNITTESTING)
  target_link_libraries(${DISCOVERER_UNIT_TESTS_LIBRARY}
    ${CGREEN_LIBRARY}
    ${CMAKE_DL_LIBS}
    ${LIBBFD_LIBRARIES})

  SET(CGREEN_RUNNER_TESTS_LIBRARY "$<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>")
  SET(DISCOVERER_ACCEPTANCE_TESTS_LIBRARY "$<TARGET_FILE_DIR:discoverer_acceptance_tests>/$<TARGET_FILE_NAME:discoverer_acceptance_tests>")
  SET(DISCOVERER_UNIT_TESTS_LIBRARY "$<TARGET_FILE_DIR:discoverer_unit_tests>/$<TARGET_FILE_NAME:discoverer_unit_tests>")

  # Due to some (of many) CMake irregularities to reference the test libraries
  # we can't just use its CMake name variable, but have to look it up with
  # some special attributes of the library:
  #     $<TARGET_FILE_DIR:the_lib>/$<TARGET_FILE_NAME:the_lib>
  #
  macro_add_test(NAME cgreen_runner_unit_tests
    COMMAND cgreen-runner ${CGREEN_RUNNER_TESTS_LIBRARY})

  macro_add_test(NAME cgreen_runner_usage
    COMMAND cgreen-runner --help)

  macro_add_test(NAME cgreen_runner_quiet
    COMMAND cgreen-runner -q ${CGREEN_RUNNER_TESTS_LIBRARY})

  macro_add_test(NAME cgreen_runner_suite_name
    COMMAND cgreen-runner -s Suite ${CGREEN_RUNNER_TESTS_LIBRARY})

  macro_add_test(NAME cgreen_runner_fail_on_non_existing_library
    COMMAND cgreen-runner Suite non_existent_library)
  set_tests_properties(cgreen_runner_fail_on_non_existing_library PROPERTIES WILL_FAIL true)

  macro_add_test(NAME cgreen_runner_fail_on_non_existing_library_with_suite
    COMMAND cgreen-runner -s Suite non_existent_library
    WILL_FAIL)
  set_tests_properties(cgreen_runner_fail_on_non_existing_library_with_suite PROPERTIES WILL_FAIL true)

  macro_add_test(NAME cgreen_runner_verbose
    COMMAND cgreen-runner -v -C ${CGREEN_RUNNER_TESTS_LIBRARY})

  macro_add_test(NAME cgreen_runner_version
    COMMAND cgreen-runner --version)

  macro_add_test(NAME cgreen_runner_single_explicit_named_test
    COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:can_match_test_name)

  macro_add_test(NAME cgreen_runner_patternmatched_testnames
    COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:can*)

  macro_add_test(NAME cgreen_runner_patternmatched_testnames_in_patternmatched_context
    COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Run*:can*)

  macro_add_test(NAME cgreen_runner_wildcarded_tests_in_named_context
    COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:*)

  macro_add_test(NAME cgreen_runner_wildcarded_tests_in_wildcarded_context
    COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> *:*)

  macro_add_test(NAME cgreen_runner_with_xml_reporter
    COMMAND cgreen-runner --xml TEST --suite cgreen_runner_tests $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>)

  macro_add_test(NAME cgreen_runner_multiple_libraries
    COMMAND cgreen-runner ${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_RUNNER_TESTS_LIBRARY})

  macro_add_test(NAME discoverer_acceptance_tests
    COMMAND cgreen-runner ${DISCOVERER_ACCEPTANCE_TESTS_LIBRARY})

  macro_add_test(NAME discoverer_unit_tests
    COMMAND cgreen-runner ${DISCOVERER_UNIT_TESTS_LIBRARY})

endif()

=== debian/changelog ===
cgreen (1.5.1-1build2) mantic; urgency=medium

  * No-change rebuild against current binutils.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Jun 2023 21:10:05 +0000

cgreen (1.5.1-1build1) lunar; urgency=medium

  * No-change rebuild against current binutils.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 17 Feb 2023 04:54:30 +0000

cgreen (1.5.1-1) unstable; urgency=medium

  * Import new upstream release
  * Update symbols
  * d/controls:
    - Add libbfd-dev to build-deps

 -- SZ Lin (林上智) <szlin@debian.org>  Sat, 16 Apr 2022 21:46:26 +0800

=== debian/control ===
Source: cgreen
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alvin Chen <sonoma001@gmail.com>
Uploaders: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: cmake, libbfd-dev, ruby-asciidoctor-pdf, debhelper-compat (= 13)
Standards-Version: 4.6.0.1
Homepage: https://github.com/cgreen-devs/cgreen
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/cgreen
Vcs-Git: https://salsa.debian.org/debian/cgreen.git

Package: libcgreen1-dev
Section: libdevel
Architecture: any
Depends: libcgreen1 (=${binary:Version}), ${misc:Depends}
Description: Cgreen library - development files
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking libraries

Package: libcgreen1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cgreen Library - Unit tests and mocking framework for C and C++
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library

Package: libcgreen1-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Cgreen Library - document
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library document

Package: cgreen1
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Cgreen Library - Library tool
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest test tool
